#include <stdio.h>

/* A screen module for gpc .... */


/* Routine descriptions. */

int tgetent(char *bp, char *name);
int tgetnum (char *id);
int tgetflag (char *id);
char * tgetstr(char *id, char **area);
char * tgoto(char *cm, int destcol, int destline);
void   tputs(char *cp, int affcnt, int (*outc)(char));
char * getenv (char *);

/* The terminal description */
char _scr_bp[1024];

/* The terminal type. */
char *_scr_tname;

/* String Storage. */
char _scr_area[512];

/* Specific pointers. */
char *_scr_ce;  /* clear to end of line */
char *_scr_cd;  /* clear to end of display */
char *_scr_cl;  /* home and clear */
char *_scr_cm;  /* cursor motion. */
char *_scr_ho;  /* home cursor */

/* Have we done the init yet? */
int _scr_did_init = 0;

/* Functions ... */

/* The output function: */
int _scr_outc (char c)
{
  fputc (c, stdout);
}

/* Called to initialize the "module." */
void _scr_init ()
{
  char *area;

  _scr_tname = getenv ("TERM");
  tgetent (_scr_bp, _scr_tname);

  /* Get all the proper strings ... */
  area = _scr_area;

  _scr_cd = tgetstr ("cd", &area);
  _scr_ce = tgetstr ("ce", &area);
  _scr_cl = tgetstr ("cl", &area);
  _scr_cm = tgetstr ("cm", &area);
  _scr_ho = tgetstr ("ho", &area);
  

  /* Error Checks */
  if (_scr_cm == NULL)
    {
      fprintf (stderr, "Terminal is not powerful enough.\n");
      exit (1);
    }
  _scr_did_init = 1;
}  


/* Cursor Movement */
void gotoxy (int x, int y)
{
  if (!_scr_did_init) _scr_init();
  tputs (tgoto (_scr_cm, x, y), 1, _scr_outc);
}


/* Clear the entire screen and move to home. */
void clearscreen ()
{
  if (!_scr_did_init) _scr_init();
  tputs (_scr_cl, 1, _scr_outc);
}


/* Clear from cursor to the end of the screen. */
void cleartoeos ()
{
  if (!_scr_did_init) _scr_init();
  tputs (_scr_cd, 1, _scr_outc);
}

/* Clear from cursor to the end of the line. */
void cleartoeol ()
{
  if (!_scr_did_init) _scr_init();
  tputs (_scr_ce, 1, _scr_outc);
}

/* Go to the home position. */
void home()
{
  if (!_scr_did_init) _scr_init();
  tputs (_scr_ho, 1, _scr_outc);
}
